'use strict';

var qe = require('crypto');
var we = require('fs');
var path = require('path');
var promises = require('fs/promises');
var Xr = require('tty');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var qe__default = /*#__PURE__*/_interopDefault(qe);
var we__default = /*#__PURE__*/_interopDefault(we);
var Xr__default = /*#__PURE__*/_interopDefault(Xr);

function bn(){if(typeof self<"u")return self;if(typeof window<"u")return window;if(typeof global<"u")return global;if(typeof globalThis<"u")return globalThis;throw new Error("unable to locate global object")}function K(){let e=bn();return e._zeedGlobal==null&&(e._zeedGlobal={}),e._zeedGlobal}function Tn(e){return e===!0||e==="true"||e==="1"||typeof e=="number"&&e!==0?e="*":e===!1||e==="false"||e===0||e==="0"||e==null||e==="null"||e==="undefined"?e="":e=String(e),e}function wn(){return Tn(typeof process<"u"?process.env.ZEED??process.env.DEBUG:typeof localStorage<"u"?localStorage.zeed??localStorage.debug:"*")}function _(e=wn()){let t,n=[],r=[];if(!e)t=function(o){return !1};else if(e==="*")t=function(o){return !0};else {let o,i=e.split(/[\s,]+/),u=i.length;for(o=0;o<u;o++){if(!i[o])continue;let a=i[o].replace(/\*/g,".*?");a[0]==="-"?n.push(new RegExp(`^${a.substr(1)}$`)):r.push(new RegExp(`^${a}$`));}t=function(a){if(n.length===0&&r.length===0)return !0;let s,c;for(s=0,c=n.length;s<c;s++)if(n[s].test(a))return !1;for(s=0,c=r.length;s<c;s++)if(r[s].test(a))return !0;return !1};}return t.accept=r,t.reject=n,t.filter=e,t}function Ln(){return typeof process<"u"?process.env.ZEED_LEVEL??process.env.LEVEL??process.env.DEBUG_LEVEL:typeof localStorage<"u"?localStorage.zeed_level??localStorage.level??localStorage.debug_level:void 0}function ve(e){if(e===!1)return Y;if(typeof e=="number")return e;if(typeof e=="string"){let t=et[e.toLocaleLowerCase().trim()];if(t!=null)return t}return V}function z(e=Ln()){let t=ve(e);return n=>n>=t}function ue(e={}){let{level:t=void 0,filter:n=void 0}=e,r=_(n),o=z(t);return i=>{if(!o(i.level)||!r(i.name))return;let u=i.name?`[${i.name}]`:"";switch(i.level){case O:console.info(`I|*   ${u}`,...i.messages);break;case I:console.warn(`W|**  ${u}`,...i.messages);break;case $:console.error(`E|*** ${u}`,...i.messages);break;default:console.debug(`D|    ${u}`,...i.messages);break}}}var V=-1,W=0,O=1,I=2,$=3,ce=4,Y=9007199254740991,et={"*":V,a:V,all:V,d:W,dbg:W,debug:W,i:O,inf:O,info:O,w:I,warn:I,warning:I,e:$,err:$,error:$,fatal:ce,off:Y,"-":Y};function tt(e=""){let t=[ue()],n=s=>!0,r=!1,o=u,i=!1;function u(s="",c){let g=ve(c??V);function l(d,m){return g<=d?m:()=>{}}let f=l(W,(...d)=>{p({name:s,messages:d,level:W});});f.label=s,f.extend=function(d){return o(s?`${s}:${d}`:d)};let p=d=>{if(n(s))for(let m of t)m&&m(d);};return f.debug=l(W,(...d)=>{p({name:s,messages:d,level:W});}),f.info=l(O,(...d)=>{p({name:s,messages:d,level:O});}),f.warn=l(I,(...d)=>{p({name:s,messages:d,level:I});}),f.error=l($,(...d)=>{p({name:s,messages:d,level:$});}),f.fatal=l(ce,(...d)=>{throw p({name:s,messages:d,level:ce}),new Error(`${d.map(String).join(" ")}`)}),f.assert=l(ce,(d,...m)=>{(d==null||typeof d=="number"&&isNaN(d)||!d)&&f.fatal(...m);}),f}function a(s="",c){let g=o(s,c);return i&&g.debug(`+++ init of logger "${s}" on level "${g.level}".`),g}return a.registerHandler=function(s){t.push(s);},a.setFilter=function(s){n=_(s);},a.setLock=(s=!0)=>r=s,a.setDebug=(s=!0)=>i=s,a.setHandlers=function(s=[]){o!==u&&(o=u),!r&&(t=[...s].filter(c=>typeof c=="function"));},a.level=V,a.setLogLevel=function(s=V){r||(a.level=s);},a.setFactory=function(s){r||(o=s);},a}var j;function Ae(e){let t=tt();return e?e(t):t.setHandlers([ue()]),t}function Ee(e){if(j==null)try{let t=K();t!=null?t?.logger==null?(j=Ae(e),t.logger=j):j=t.logger:j=Ae(e);}catch{j=Ae(e);}return j}function nt(){if(j!=null)return j;try{let e=K();if(e?.logger!=null)return e.logger}catch{}}function U(e,t){return Ee()(e,t)}function vn(...e){throw nt()?.("assert")?.fatal(...e),new Error(`${e.map(String).join(" ")}`)}function bo(e,...t){(e==null||typeof e=="number"&&isNaN(e)||!e)&&vn(...t);}var rt=(e,t)=>t instanceof Object&&!Array.isArray(t)?Object.keys(t).sort().reduce((n,r)=>(n[r]=t[r],n),{}):t;function wo(e,t=void 0){return JSON.stringify(e,rt,t)}function An(e,t){let n=[],r=[];return t==null&&(t=function(o,i){return n[0]===i?"[Circular ~]":`[Circular ~.${r.slice(0,n.indexOf(i)).join(".")}]`}),function(o,i){if(n.length>0){let u=n.indexOf(this);~u?n.splice(u+1):n.push(this),~u?r.splice(u,1/0,o):r.push(o),~n.indexOf(i)&&(i=t?.call(this,o,i));}else n.push(i);i=rt(o,i);try{return e==null?i:e.call(this,o,i)}catch{}return String(i)}}function M(e,t,n,r){return JSON.stringify(e,An(t,r),n)}var Lo=M;function En(e){let t=unescape(encodeURIComponent(e)),n=t.length,r=new Uint8Array(n);for(let o=0;o<n;o++)r[o]=t.codePointAt(o)||0;return r}function Pn(e){let t=e.length,n="",r=0;for(;t>0;){let o=t<1e4?t:1e4,i=e.subarray(r,r+o);r+=o,n+=String.fromCodePoint.apply(null,i),t-=o;}return decodeURIComponent(escape(n))}var le;function ot(e){if(le==null&&(le=En,typeof TextEncoder<"u")){let t=new TextEncoder;le=n=>t.encode(n);}return le(e.normalize("NFC"))}var fe;function it(e){if(fe==null&&(fe=Pn,typeof TextDecoder<"u")){let t=new TextDecoder("utf-8",{ignoreBOM:!0});fe=n=>t.decode(n);}return fe(e).normalize("NFC")}function F(e){return e instanceof ArrayBuffer?new Uint8Array(e):typeof e=="string"?ot(e):e.length?new Uint8Array(e):e}function Eo(...e){let t=0,n=e.flat(1).map(i=>{let u=F(i);return t+=u.length,u}),r=new Uint8Array(t),o=0;for(let i of n)r.set(i,o),o+=i.length;return r}function st(e){if(typeof Buffer<"u")return Buffer.from(F(e)).toString("hex");let t="0123456789abcdef",n="";for(let r of [...F(e)])n+=t[r>>4]+t[r&15];return n}function at(e){return Uint8Array.from(e.match(/.{1,2}/g).map(t=>parseInt(t,16)))}function ut(e,t=!1){let n=F(e),r="";if(typeof Buffer<"u")r=Buffer.from(n).toString("base64");else {let o="";for(let i=0;i<n.byteLength;i++)o+=String.fromCharCode(n[i]);r=btoa(o);}return t?r.replaceAll("=",""):r}function Po(e){let t=F(e);if(typeof Buffer<"u")return Buffer.from(t).toString("base64url").replaceAll("=","");let n="";for(let r=0;r<t.byteLength;r++)n+=String.fromCharCode(t[r]);return btoa(n).replaceAll("+","-").replaceAll("/","_").replaceAll("=","")}function Dn(e){if(e=e.replaceAll("-","+").replaceAll("_","/"),typeof Buffer<"u"){let r=Buffer.from(e,"base64");return new Uint8Array(r.buffer,r.byteOffset,r.byteLength)}let t=atob(e),n=new Uint8Array(t.length);for(let r=0;r<t.length;r++)n[r]=t.charCodeAt(r);return n}function Do(e){return it(Dn(e))}function ct(e,t){if(e.byteLength!==t.byteLength)return !1;let n=F(e),r=F(t);for(let o=0;o<n.length;o++)if(n[o]!==r[o])return !1;return !0}function Pe(e){return ot(M(e))}function De(e){return JSON.parse(it(e))}function lt(e,t){if(typeof e!="string")if(e instanceof ArrayBuffer&&e.byteLength!==void 0)e=String.fromCharCode.apply(String,[].slice.call(new Uint8Array(e)));else if(Array.isArray(e))e=String.fromCharCode.apply(String,e);else if(e.constructor===Uint8Array)e=String.fromCharCode.apply(String,[].slice.call(e));else return !1;t=t||16;let n=[],r="0123456789ABCDEF";for(let o=0;o<e.length;o+=t){let i=e.slice(o,Math.min(o+t,e.length)),u=`0000${o.toString(16)}`.slice(-4),a=i.split("").map(c=>{let g=c.charCodeAt(0);return ` ${r[(240&g)>>4]}${r[15&g]}`}).join("");a+="   ".repeat(t-i.length);let s=i.replace(/[\x00-\x1F\x20]/g,".");s+=" ".repeat(t-i.length),n.push(`${u} ${a}  ${s}`);}return n.join(`
`)}function Q(e=16){let t=new Uint8Array(e);if(typeof crypto<"u"&&crypto.getRandomValues)crypto.getRandomValues(t);else for(let n=0;n<e;n++)t[n]=Math.floor(Math.random()*256);return t}var dt="SHA-256",Se="AES-GCM",ft="PBKDF2",Sn=1e5;async function Uo(e,t=dt){return F(await crypto.subtle.digest(t,F(e)))}async function Mo(e,t={}){let n=F(e),r=await crypto.subtle.importKey("raw",n,ft,!1,["deriveKey"]);return await crypto.subtle.deriveKey({name:ft,salt:t.salt?F(t.salt):new Uint8Array(0),iterations:t.iterations??Sn,hash:dt},r,{name:Se,length:256},!0,["encrypt","decrypt"])}function pt(){return new Uint8Array([1,1])}async function gt(e,t){let n=pt(),r=Q(12),o=await crypto.subtle.encrypt({name:Se,iv:r},t,e),i=new Uint8Array(o),u=n.length+r.length+i.length,a=new Uint8Array(u),s=0;return a.set(n,s),s+=n.length,a.set(r,s),s+=r.length,a.set(i,s),a}async function mt(e,t){let n=e.subarray(0,2);if(!ct(n,pt()))return Promise.reject(new Error(`Unknown magic ${n}`));let r=e.subarray(2,2+12),o=e.subarray(2+12,e.length),i=await crypto.subtle.decrypt({name:Se,iv:r},t,o);return new Uint8Array(i)}function Rn(){return crypto.getRandomValues(new Uint32Array(1))[0]/4294967295}function S(){return typeof crypto<"u"?Rn():Math.random()}function ko(e=.25){return S()<e}function Co(e=100,t=0){return t+Math.floor(S()*(e-t))}function Io(e=100,t=0){return t+S()*(e-t)}function $o(e,t,n){return Math.max(e,Math.min(n,t))}function Un(e){return e.reduce((t,n)=>t+n,0)}function Oo(e){return Un(e)/e.length}function Bo(e){return !/^1?$|^(11+?)\1+$/.test("1".repeat(e))}function _o(e){for(let t=2;t<e;t++)if(e%t===0)return !1;return e>1}var Re=6;function jo(e=0,t=1,n){Re=((n??Re)*9301+49297)%233280;let r=Re/233280;return t+r*(e-t)}function Mn(e=""){let[t="",n="asc"]=e.split(" ");return n=n.toLowerCase(),{field:t,orderby:n,asc:n!=="desc",desc:n==="desc"}}function Ho(e,t=!0){return `${e} ${t?"asc":"desc"}`}function Ue(e,t,n=!0){let r=e||0,o=t||0;return r>o?n?1:-1:r<o?n?-1:1:0}function Go(e,...t){if(t.length>0){let n=t.map(Mn),r=Array.from(e);return r.sort((o,i)=>{for(let{field:u,asc:a}of n){let s=Ue(o[u],i[u],a);if(s!==0)return s}return 0}),r}return e}function Me(e){return e.filter((t,n)=>e.indexOf(t)===n)}function Fn(e,t){return Me(e.filter(n=>!t.includes(n)))}function kn(...e){return Me(e.reduce((t=[],n)=>t.concat(n),[]))}function X(...e){return e.flat(1/0)}function Cn(e,t){return Me(e).filter(n=>t.includes(n))}function Wo(e,t){return Fn(kn(e,t),Cn(e,t))}function yt(e,t){if(e&&Array.isArray(e)){let n;for(;(n=e.indexOf(t))!==-1;)e.splice(n,1);return e}return []}function Jo(e,t){return e.includes(t)||e.push(t),e}function Fe(e,t){return e.splice(0,e.length,...e.filter(t)),e}function Zo(e,t){let n=e.findIndex(r=>r===t);return n>=0?e.splice(n,1):e.push(t),e}function Ko(e){return e.splice(0,e.length),e}function In(e,t=Ue){return Array.from(e).sort(t)}function Yo(e){return In(e,(t,n)=>t-n)}function $n(e,t){return e.length===t.length&&e.every((n,r)=>n===t[r])}function ht(e){return e.sort(()=>S()>.5?1:-1),e}function Qo(e){return ht(Array.from(e))}function Xo(e){for(;e.length>1;){let t=Array.from(e);if(ht(t),!$n(e,t))return t}return e}function ei(e){return e[Math.floor(S()*e.length)]}function ti(...e){return X(e).reduce((t,n)=>t!=null?n>t?n:t:n,void 0)}function ni(...e){return X(e).reduce((t,n)=>t!=null?n<t?n:t:n,void 0)}function ri(...e){return X(e).reduce((t,n)=>t+n,0)}function oi(...e){let t=X(e);return t.reduce((n,r)=>n+r,0)/t.length}function ii(e,t){let n=[],r=0,o=e.length;for(;r<o;)n.push(e.slice(r,r+=t));return n}function si(e=0,t){if(e<=0)return [];let n=new Array(e);for(let r=0;r<e;r++)n[r]=t instanceof Function?t(r):t;return n}var On={2:"01",8:"01234567",11:"0123456789a",16:"0123456789abcdef",32:"0123456789abcdefghjkmnpqrtuvwxyz","32-crockford":"0123456789ABCDEFGHJKMNPQRSTVWXYZ","32-geohash":"0123456789bcdefghjkmnpqrstuvwxyz","32-agnoster":"0123456789abcdefghjkmnpqrtuvwxyz","32-rfc":"ABCDEFGHIJKLMNOPQRSTUVWXYZ234567","32-hex":"0123456789ABCDEFGHIJKLMNOPQRSTUV","32-zbase":"ybndrfg8ejkmcpqxot1uwisza345h769",36:"0123456789abcdefghijklmnopqrstuvwxyz",58:"123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz",62:"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz",64:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/","64-url":"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_",66:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_.!~",85:"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz!#$%&()*+-;<=>?@^_`{|}~"};function Bn(e){let t=On[String(e)];if(!t)if(typeof e=="string")t=e;else throw new Error(`Unknown base ${e}`);if(t.length>=255)throw new TypeError("Alphabet too long");let n=new Uint8Array(256);for(let c=0;c<n.length;c++)n[c]=255;for(let c=0;c<t.length;c++){let g=t.charAt(c),l=g.charCodeAt(0);if(n[l]!==255)throw new TypeError(`${g} is ambiguous`);n[l]=c;}let r=t.length,o=t.charAt(0),i=Math.log(r)/Math.log(256),u=Math.log(256)/Math.log(r);function a(c,g=-1){let l=F(c);if(l.byteLength===0)return "";let f=0,p=0,d=l.byteLength;for(;p!==d&&l[p]===0;)p++;let m=(d-p)*u+1>>>0,b=new Uint8Array(m);for(;p!==d;){let A=l[p],P=0;for(let h=m-1;(A!==0||P<f)&&h!==-1;h--,P++)A+=256*b[h]>>>0,b[h]=A%r>>>0,A=A/r>>>0;if(A!==0)throw new Error("Non-zero carry");f=P,p++;}let y=m-f;for(;y!==m&&b[y]===0;)y++;let w="";for(;y<m;++y)w+=t.charAt(b[y]);return g>0?w.padStart(g,o):w}function s(c,g=-1){if(typeof c!="string")throw new TypeError("Expected String");if(c.length===0)return new Uint8Array;c=c.replace(/\s+/gi,"");let l=0,f=0;for(;c[l]===o;)l++;let p=(c.length-l)*i+1>>>0,d=new Uint8Array(p);for(;c[l];){let b=n[c.charCodeAt(l)];if(b===255)throw new Error(`Unsupported character "${c[l]}"`);let y=0;for(let w=p-1;(b!==0||y<f)&&w!==-1;w--,y++)b+=r*d[w]>>>0,d[w]=b%256>>>0,b=b/256>>>0;if(b!==0)throw new Error("Non-zero carry");f=y,l++;}let m=p-f;for(;m!==p&&d[m]===0;)m++;return g>0?new Uint8Array([...new Uint8Array(g-d.length+m),...d.slice(m)]):d.slice(m)}return {encode:a,decode:s}}var de;function q(e){de==null&&(de=new Map);function t(){let o=de.get(e);return o==null&&(o=Bn(e),de.set(e,o)),o}function n(o,i=-1){return t().encode(o,i)}function r(o,i=-1){return t().decode(o,i)}return {encode:n,decode:r}}function ke(e,t=-1){return q(32).encode(e,t)}function xt(e,t=-1){return q(32).decode(e.toLocaleLowerCase().replaceAll("l","1").replaceAll("s","5").replaceAll("o","0").replaceAll("i","1"),t)}function ci(e,t=-1){return q(16).encode(e,t)}function li(e,t=-1){return q(16).decode(e,t)}function fi(e,t=-1){return q(58).encode(e,t)}function di(e,t=-1){return q(58).decode(e,t)}function Ce(e,t=-1){return q(62).encode(e,t)}function bt(e,t=-1){return q(62).decode(e,t)}function pi(e,t){return Math.ceil(e*(Math.log(256)/Math.log(t)))}var Tt=e=>(e.length>0&&(/^[A-Z0-9_\-\ ]*$/g.test(e)&&(e=e.toLowerCase()),e=e.replace(/^[-_\ ]+/gi,"").replace(/[-_\ ]+$/gi,"").replace(/[-_\ ]+([a-z0-9])/gi,(t,n)=>n.toUpperCase()),e=e[0].toLowerCase()+e.substring(1)),e);function _n(e){return e.charAt(0).toUpperCase()+e.toLowerCase().slice(1)}function mi(e){return e.replace(/\w\S*/g,_n)}function yi(e,t="-"){return t=typeof t>"u"?"_":t,e.replace(/([a-z\d])([A-Z])/g,`$1${t}$2`).replace(/([A-Z]+)([A-Z][a-z\d]+)/g,`$1${t}$2`).toLowerCase()}var wt=["1","true","yes","y","on"];function bi(e,t=!1){return e==null||typeof e!="string"?t:wt.includes(String(e).trim().toLowerCase())}function Ti(e,t=0){return e==null||typeof e!="string"?t:parseInt(e.trim(),10)??t}function wi(e,t=0){return e==null||typeof e!="string"?t:parseFloat(e.trim())??t}function ee(e,t=!1){return e==null?t:typeof e=="boolean"?e:typeof e=="number"?e!==0:wt.includes(String(e).trim().toLowerCase())}function jn(e,t=0){return e==null?t:typeof e=="boolean"?e?1:0:typeof e=="number"?Math.floor(e):parseInt(String(e).trim(),10)??t}function Nn(e,t=0){return e==null?t:typeof e=="boolean"?e?1:0:typeof e=="number"?Math.floor(e):parseFloat(String(e).trim())??t}function Ie(e,t=""){return e==null?t:String(e)??t}var Li=Nn,vi=jn,Ai=Ie,Ei=ee;function Hn(e,t={}){let{trace:n=!0,pretty:r=!0}=t;return e.map(o=>{if(o&&typeof o=="object"){if(r&&(o instanceof Uint8Array||o instanceof ArrayBuffer))return `
${lt(o)}
`;if(o instanceof Error)return n?`${o.name||"Error"}: ${o.message}
${o.stack}`:`${o.name||"Error"}: ${o.message}`;try{return r?JSON.stringify(o,null,2):JSON.stringify(o)}catch{}}return String(o)})}function pe(e,t={}){return Hn(e,t).join(" ")}function Pi(e){try{return decodeURIComponent(escape(e))}catch{}return e}var Lt=864e5;function Oe(e){return Math.floor(e/1e4)}function vt(e){return Math.floor(e/100%100)}function Gn(e){return Math.floor(e%100)}function Si(e){return [Oe(e),vt(e),Gn(e)]}function At(e,t=!1){return t?new Date(`${Vn(e)}T00:00:00.000Z`):new Date(e/1e4,e/100%100-1,e%100)}function Et(){return me(new Date)}function Ri(e,t=!1){if(typeof e=="number")return e<100?void 0:e;if(typeof e=="string")return Pt(e);if(Array.isArray(e)&&e.length===3){let[n,r,o]=e;return Be(n,r,o)}else if(e instanceof Date)return me(e,t)}function Ui(e){return At(e,!0)}function me(e,t=!1){return t?Pt(e.toISOString()):e.getFullYear()*1e4+(e.getMonth()+1)*100+e.getDate()}function Mi(e){return me(e,!0)}function $e(e,t=!0){return At(e,t).getTime()}function zn(e,t=!0){return me(new Date(e),t)}function Vn(e,t="-"){let n=String(e);return n.slice(0,4)+t+n.slice(4,6)+t+n.slice(6,8)}function Be(e,t=1,n=1){if(!(t<1||t>12||n<1||n>31))return e*1e4+t*100+n}function Pt(e){let t=String(e).replace(/[^0-9]/g,"").slice(0,8);if(t.length===8)return +t}function Fi(e,t=0){let n=Oe(e),r=vt(e);return t!==0&&(r+=t,n+=Math.floor((r-1)/12),r=Math.floor((r-1)%12)+1,r===0&&(r=12)),Be(n,r,1)}function ki(e,t=0){let n=Oe(e);return Be(n+t,1,1)}function ge(e,t){return zn($e(e)+t*864e5)}function Ci(e,t){return Math.round(($e(t)-$e(e))/864e5)}function Ii(e,t){let n=[];for(t==null&&(t=Et()),e<0&&(e=ge(t,e+1));e<=t;)n.push(e),e=ge(e,1);return n}function*$i(e,t){let n=[];for(t==null&&(t=Et()),e<0&&(e=ge(t,e+1));e<=t;)yield e,e=ge(e,1);return n}function Dt(){let e,t;return [new Promise((r,o)=>{e=r,t=o;}),e,t]}async function Bi(e){return new Promise(t=>setTimeout(t,e))}async function _i(){return new Promise(e=>setTimeout(e,0))}async function ji(e,t,n="timeoutReached"){return new Promise(async(r,o)=>{let i=!1,u=setTimeout(()=>{i=!0,r(n);},t);try{let a=await e;clearTimeout(u),i||r(a);}catch(a){clearTimeout(u),i||o(a);}})}function Ni(e){return e==="timeoutReached"||e?.name==="Timeout reached"}async function St(e,t){return t<=0?await e:new Promise(async(n,r)=>{let o=!1,i=setTimeout(()=>{o=!0,r(new Error("Timeout reached"));},t);try{let u=await e;clearTimeout(i),o||n(u);}catch(u){clearTimeout(i),o||r(u);}})}function Hi(e,t,n=1e3){return new Promise((r,o)=>{let i=s=>{a&&(clearTimeout(a),u(),r(s));},u=()=>{a=null,e.off?e.off(t,i):e.removeEventListener&&e.removeEventListener(t,i);},a=setTimeout(()=>{u(),o(new Error("Did not response in time"));},n);e.on?e.on(t,i):e.addEventListener&&e.addEventListener(t,i);})}function k(e){return !!(e&&(e instanceof Promise||typeof e.then=="function"))}function N(e){return Promise.resolve(e)}var v=class{get value(){return this.days}constructor(t){if(typeof t=="number"){this.days=t;return}if(t!=null&&(t=v.from(t)?.days),t==null){let n=new Date;this.days=n.getFullYear()*1e4+(n.getMonth()+1)*100+n.getDate();}else this.days=t;}static fromNumber(t){return new v(t)}static fromString(t){return v.from(+t.replace(/[^0-9]/g,"").slice(0,8))}static fromDate(t,n=!1){return n?v.fromString(t.toISOString().substr(0,10)):v.from(t.getFullYear()*1e4+(t.getMonth()+1)*100+t.getDate())}static fromDateGMT(t){return v.fromDate(t,!0)}static from(t,n=!1){if(typeof t=="number")return t<100?void 0:new v(t);if(typeof t=="string")return v.fromString(t);if(Array.isArray(t)&&t.length===3){let[r,o=1,i=1]=t;return o<1||o>12||i<1||i>31?void 0:new v(r*1e4+o*100+i)}else {if(t instanceof Date)return v.fromDate(t,n);if(t instanceof v)return t}}toNumber(){return this.days}toJson(){return this.days}toString(t="-"){let n=String(this.days);return n.slice(0,4)+t+n.slice(4,6)+t+n.slice(6,8)}toDate(t=!1){return t?new Date(`${this.toString()}T00:00:00.000Z`):new Date(this.days/1e4,this.days/100%100-1,this.days%100)}toDateGMT(){return this.toDate(!0)}get year(){return Math.floor(this.days/1e4)}get month(){return Math.floor(this.days/100%100)}get day(){return Math.floor(this.days%100)}dayOffset(t){return v.fromDateGMT(new Date(this.toDateGMT().getTime()+t*864e5))}monthStart(){return v.from([this.year,this.month,1])}yearStart(){return v.from([this.year,1,1])}monthOffset(t){let n=this.month+t,r=Math.floor((n-1)%12)+1;r===0&&(r=12);let o=Math.floor((n-1)/12);return v.from([this.year+o,r,this.day])}daysUntil(t){return Math.round((new v(t)?.toDateGMT().getTime()-this.toDateGMT().getTime())/864e5)}yesterday(){return this.dayOffset(-1)}tomorrow(){return this.dayOffset(1)}};async function Vi(e,t,n){let r=v.from(e),o=v.from(t);for(;r&&o&&r?.days<=o?.days;){let i=n(r);k(i)&&await i,r=r.dayOffset(1);}}function qi(){return new v}function Wi(e){return new v(e)}function Ji(e){return v.fromDate(new Date(e)).days}function qn(e,t=2){return +(+e).toFixed(t)}function Ki(e,t=2){return +(+e/10**t).toFixed(t)}function Yi(e,t=2){return Math.round(+e*10**t)}function Qi(e,t=2){return t*(qn(e,t)%1)}function H(e){return e!=null&&typeof e=="object"}function _e(e){return Object(e)!==e}function G(e){return Array.isArray(e)}function ye(e){return H(e)&&!G(e)}function es(e){return e?.constructor===Object}function Rt(e){return typeof e=="string"}function Ut(e){return typeof e=="number"&&!isNaN(e)}function ts(e){return Ut(e)&&Number.isInteger(e)}function ns(e){return Ut(e)&&Number.isSafeInteger(e)}function Mt(e){return typeof e=="boolean"}function rs(e){return e==null}function os(e){return e==null}function is(e){return H(e)&&e.constructor.name==="Uint8Array"}function Ft(e){return e!=null}function ss(e){return e!=null&&e!==!1&&e!==!0}function Wn(e,t,n=new WeakSet){if(e===t)return !0;if(n.has(t)||(_e(t)||n.add(t),!(e instanceof Object)||!(t instanceof Object))||e.constructor!==t.constructor||e.length!==t.length)return !1;for(let r in e){if(!e.hasOwnProperty(r))continue;if(!t.hasOwnProperty(r))return !1;let o=e[r],i=t[r];if(!Wn(o,i,n))return !1}for(let r in t)if(t.hasOwnProperty(r)&&!e.hasOwnProperty(r))return !1;return !0}function Jn(e,t=new WeakSet){if(t.has(e))return "[Circular ~]";if(_e(e)||t.add(e),ye(e)){for(let n in e)if(e.hasOwnProperty(n)){if(e[n]===void 0){delete e[n];continue}Jn(e[n],t);}}else if(G(e))for(let n=e.length-1;n>=0;n--)e[n]===void 0&&e.splice(n,1);return e}function he(e,...t){for(let n of t)H(e)||(e={}),!(n==null||!H(n))&&Object.keys(n).forEach(r=>{let o=e[r],i=n[r];Array.isArray(o)&&Array.isArray(i)?e[r]=o.concat(i):H(o)&&H(i)?e[r]=he(Object.assign({},o),i):e[r]=i;});return e}var kt=e=>e.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/'/g,"&apos;").replace(/"/g,"&quot;"),ls=e=>e.replace(/&lt;/gi,"<").replace(/&gt;/gi,">").replace(/&quot;/gi,'"').replace(/&apos;/gi,"'").replace(/&amp;/gi,"&");function ds(e,t,n=[]){return e.filter(r=>!t.some(o=>!o(r))).map(r=>{for(let o of n)r=o(r);return r}).filter(r=>r!=null)}function ps(e,t){return e.reduce((n,r)=>{let o=String(r[t]);return (n[o]=n[o]||[]).push(r),n},{})}function gs(e,t){return Array.from(e.reduce((n,r)=>n.add(r[t]),new Set))}function ms(e,t){return e.map(n=>n[t])}function xs(e,t){return H(e)?Object.fromEntries(Object.entries(e).map(([n,r])=>{let o=t(n,r);return G(o)&&o.length===2?o:[n,o]}).filter(n=>n!=null)):{}}function bs(e,t){return t.dispose&&e.dispose&&t.dispose.add(e.dispose),Object.assign(e,t)}function Ts(e){return Object.keys(e).length<=0}var Ct=/[\u0000-\u001F\u0080-\u009F]/g,Zn=/^\.+/,Kn=/\.+$/;function It(){return /[<>:"/\\|?*\u0000-\u001F]/g}function Yn(){return /^(con|prn|aux|nul|com\d|lpt\d)$/i}function $t(e,t="_"){if(typeof e!="string")throw new TypeError("Expected a string");if(It().test(t)&&Ct.test(t))throw new Error("Replacement string cannot contain reserved filename characters");return e=e.replace(It(),t).replace(Ct,t).replace(Zn,t).replace(Kn,""),e=Yn().test(e)?e+t:e,e.slice(0,100)}var Qn=/[\\\-\[\]\/{}()*+?.^$|]/g;function Ot(e){return e?e instanceof RegExp?e.source:e.replace(Qn,"\\$&"):""}var re=e=>Math.abs(e)%1===.5,Bt=e=>e%2===0,As=e=>Math.ceil(e),Es=e=>Math.floor(e),Ps=e=>Math.round(e),Ds=e=>{let t=Math.round(e);return re(e)&&Bt(t)?t-1:t},Ss=e=>re(e)?Math.sign(e)*Math.ceil(Math.abs(e)):Math.round(e),Rs=e=>re(e)?Math.floor(e):Math.round(e),Us=e=>{let t=Math.round(e);return re(e)?Bt(t)?t:t-1:t},Ms=e=>re(e)?Math.sign(e)*Math.floor(Math.abs(e)):Math.round(e);function _t(e){return e.reduce((t,n)=>Math.min(t,n.sort_weight||0),0)-1-S()}function jt(e){return e.reduce((t,n)=>Math.max(t,n.sort_weight||0),0)+1+S()}function Cs(e,t,n){let r=n.length,o=e<t;if(r<=0||e>=r-1)return jt(n);if(e<=0)return _t(n);n=Xn([...n]);let i=o?-1:0,u=n[e+i].sort_weight||0,s=(n[e+i+1].sort_weight||0)-u;if(s===0)return o?_t(n):jt(n);let c=u+s/2,g=s*.01*(S()-.5);return c+g}function Xn(e){return e.sort((t,n)=>(t.sort_weight||0)-(n.sort_weight||0)),e}function Os(e={}){let{getter:t=a=>a.sort}=e;function n(a){return a.sort((s,c)=>(t(s)||0)-(t(c)||0)),a}function r(a){return a.reduce((s,c)=>Math.min(s,t(c)||0),0)-1-S()}function o(a){return a.reduce((s,c)=>Math.max(s,t(c)||0),0)+1+S()}function i(a,s){a==null&&(a=(s??0)-1),s==null&&(s=(a??0)+1);let c=s-a,g=a+c/2,l=c*.01*(S()-.5);return g+l}function u(a,s,c){let g=c.length,l=a<s;if(g<=0||a>=g-1)return o(c);if(a<=0)return r(c);c=n([...c]);let f=l?-1:0,p=t(c[a+f])||0,m=(t(c[a+f+1])||0)-p;if(m===0)return l?r(c):o(c);let b=p+m/2,y=m*.01*(S()-.5);return b+y}return {start:r,end:o,between:i,move:u,items:n}}var er=/((?:(?:(?:https?|ftp):)?\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z0-9\u00A1-\uFFFF][a-z0-9\u00A1-\uFFFF_-]{0,62})?[a-z0-9\u00A1-\uFFFF]\.)+(?:[a-z\u00A1-\uFFFF]{2,}\.?))(?::\d{2,5})?(?:[/?#]\S*)?)/gim;function js(e){return e.split(er).map((t,n)=>{let r=kt(t);return n%2?`<a target="_blank" href="${r}">${tr(r)}</a>`:r}).join("")}function tr(e){return e.replace(/^https?:\/\/(www\.)?/,"").replace(/\/$/,"")}function Nt(e){let t=[];for(let[n,r]of Object.entries(e))if(r!=null){Array.isArray(r)||(r=[r]);for(let o of r)o!=null&&t.push(`${encodeURIComponent(n)}=${encodeURIComponent(String(o))}`);}return t.join("&")}function Ns(e){let t={},n=(e[0]==="?"?e.substr(1):e).split("&");for(let r=0;r<n.length;r++){let o=n[r].split("="),i=decodeURIComponent(o[0]),u=decodeURIComponent(o[1]||"");t[i]!=null?(Array.isArray(t[i])||(t[i]=[t[i]]),t[i].push(u)):t[i]=u;}return t}function zs(e,t,n){let r=e[t];return r===void 0&&(r=n(t,e),e[t]=r),r}async function Vs(e,t,n){let r=e[t];return r===void 0&&(r=await n(t,e),e[t]=r),r}function qs(e){return e!=null?e.size!=null?e.size:e.length!=null?e.length:Object.keys(e).length:0}function Ws(e){return e!=null&&e.length>0?e[e.length-1]:void 0}function Js(e){try{if(e!=null)return Array.isArray(e)||typeof e=="string"?e.length<=0:e?.size!=null?e.size<=0:Object.keys(e).length<=0}catch(t){console.warn("Failed to check if empty for",e,t);}return !0}function te(e){return Object(e)!==e?e:JSON.parse(M(e))}function Zs(e){return Object(e)!==e?e:JSON.parse(M(e))}function Ks(e){let t=new Map;return n=>{if(t.has(n))return t.get(n);let r=e(n);return t.set(n,r),r}}function Ys(e){let t=new Map;return async(...n)=>{let r=M(n);if(t.has(r))return t.get(r);let o=await e(...n);return t.set(r,o),o}}function Qs(e,t){let n=[];for(let r=0;r<e;r++)n.push(t(r,e));return n}var nr=/\\\s|\s+|#[^\n]*\n?/gm,rr=/\(\?P?<(\w[\w\d_]+)>|\((?!\?(:|\!|=|<=|<\!))/gm,Ht=/^((?:\(\?[\w$]+\))?)\(\?<([=!])([\s\S]*?)\)/gm;function or(e){return typeof e=="string"?e:e.source||""}function ea(e){return e.replace(/[-\[\]{}()*+?.,\\^$|#\s]/g,"\\$&")}var Gt=class{constructor(t,n){this.namedGroups={};this.names=[];let r=n??"",o;if(t instanceof RegExp?(n==null&&(r=t.flags),o=t.source):o=t,r&&r.includes("x")&&(r=r.replace("x",""),o=o.replace(nr,a=>a[0]==="\\"?a:"")),!(t instanceof RegExp)){let a=0;o=o.replace(rr,(s,c)=>(a+=1,c?(c!=="index"&&c!=="length"&&!this.namedGroups[c]&&(this.namedGroups[c]=a),"("):s)),this.names=Object.keys(this.namedGroups);}o=or(o),Ht.lastIndex=0;let u=Ht.exec(o);u&&(this.lookBehind={rx:new RegExp(`${u[3]}$(?!\\s)`),expect:u?u[2]==="=":!u},o=o.substr(u[0].length)),this.rx=new RegExp(o,r);}get lastIndex(){return this.rx.lastIndex}set lastIndex(t){this.rx.lastIndex=t;}_handleMatch(t){if(this.lookBehind){let n=t.input.slice(0,t.index);if(this.lookBehind.expect!==this.lookBehind.rx.test(n))return null}for(let n of this.names)t[n]=t[this.namedGroups[n]];return t}exec(t){let n;for(;n=this.rx.exec(t);)if(this.rx.lastIndex===n.index&&this.rx.lastIndex++,n=this._handleMatch(n),n!=null)return n}execAll(t){let n=[],r;for(this.rx.lastIndex=0;r=this.exec(t);)n.push(r);return this.rx.lastIndex=0,n}replace(t,n){let r=typeof n=="function"?n:()=>n;return t.replace(this.rx,o=>r(o))}};var ir=",";function ra(e,t={}){let{separator:n=ir}=t,r="";for(let o=0;o<e.length;o++)r+=`${e[o].map(i=>{if(i==null||i==="")return "";if(Mt(i))return i?1:0;let u=String(i);return (ye(i)||G(i))&&(u=M(i)),u.includes('"')||u.includes(`
`)||u.includes(n)?`"${u.replace(/"/g,'""')}"`:u}).join(n)}
`;return r}function sr(e,t={}){let n=/("((?:(?:[^"]*?)(?:"")?)*)"|([^,;\t\n]*))([,;\t]|\n|\r\n)/g;t.separator&&(n=new RegExp(n.source.replaceAll(",;\\t",Ot(t.separator)),n.flags));let r=[],o=[],i,u=`${e.replaceAll(`\r
`,`
`).trim()}
`;for(;i=n.exec(u);){let a=i[2]??i[3]??"";a=a.replaceAll('""','"'),o.push(a),i[4]===`
`&&(r.push(o),o=[]);}return r}function oa(e,t={}){let n=sr(e,t),r=n[0];return n.slice(1).map(o=>Object.fromEntries(o.map((i,u)=>[r[u],i])))}async function ar(e){typeof e=="function"?await N(e()):k(e)?await e:typeof e.dispose=="function"?await N(e.dispose()):k(e.dispose)?await e.dispose:typeof e.cleanup=="function"?await N(e.cleanup()):k(e.cleanup)&&await e.cleanup;}function oe(e){let t=e;t!=null&&(Rt(t)?t={name:t}:"debug"in t&&"label"in t&&(t={name:t.label,log:t}));let n=t?.name,r=t?.log??U("zeed:dispose"),o=[],i=async s=>{s!=null&&o.includes(s)&&(Fe(o,c=>c!==s),await ar(s));},u=async()=>{for(n&&r.debug(`dispose "${n}": ${o.length} entries`);o.length>0;)await i(o[0]);},a=s=>{if(s!=null)return o.unshift(s),()=>i(s)};return Object.assign(u,{track:a,add:a,untrack:i,dispose:u,exec:u,getSize(){return o.length},isDisposed(){return o.length<=0}})}var la=oe;function fa(e={}){let{mode:t="fifo"}=e,n=[],r=async(i=!1)=>{for(;n.length>0;){let u=n[0];if(Fe(n,a=>a!==u),typeof u=="function"){let a=u();if(k(a)){if(i)throw new Error(`Expected sync only function, but found async: ${u}`);await a;}}else if(k(u)){if(i)throw new Error(`Expected sync only function, but found async: ${u}`);await u;}else throw new Error(`Unhandled disposable: ${u}`)}};return Object.assign(r,{add:i=>{t==="lifo"?n.unshift(i):n.push(i);},exec:r,getSize(){return n.length}})}function da(e,t=0){let n=setTimeout(e,t);return ()=>{n&&(clearTimeout(n),n=void 0);}}function pa(e,t){let n=setInterval(e,t);return ()=>{n&&(clearInterval(n),n=void 0);}}function ga(e,t,n,...r){return e==null?()=>{}:(e.on?e.on(t,n,...r):e.addEventListener&&e.addEventListener(t,n,...r),()=>{e.off?e.off(t,n,...r):e.removeEventListener&&e.removeEventListener(t,n,...r);})}function ha(){let e=!0;return (t,n)=>{let r=!1;if(e){e=!1;try{t(),r=!0;}finally{e=!0;}}else n!==void 0&&n();return r}}function xa(){let e=!0;return async(t,n)=>{let r=!1;if(e){e=!1;try{let o=t();k(o)&&await o,r=!0;}finally{e=!0;}}else if(n!==void 0){let o=n();k(o)&&await o;}return r}}var C=class{constructor(){this.subscribers={};this.subscribersOnAny=[];this._logEmitter=U("zeed:emitter","error");this.dispose=oe();this.call=new Proxy({},{get:(t,n)=>async(...r)=>await this.emit(n,...r)});}async emit(t,...n){let r=!1;try{let o=this.subscribers[t]||[];if(this._logEmitter.debug("emit",this?.constructor?.name,t,...n,o),this.subscribersOnAny.forEach(i=>i(t,...n)),o.length>0){let i=o.map(u=>{try{return N(u(...n))}catch(a){this._logEmitter.warn("emit warning:",a);}return null}).filter(u=>u!=null);r=!0,await Promise.all(i);}}catch(o){this._logEmitter.error("emit exception",o);}return r}onAny(t){this.subscribersOnAny.push(t);}on(t,n){let r=this.subscribers[t]||[];return r.push(n),this.subscribers[t]=r,()=>{this.off(t,n);}}onCall(t){for(let[n,r]of Object.entries(t))this.on(n,r);}once(t,n){let r=async(...o)=>(this.off(t,r),await N(n(...o)));return this.on(t,r),()=>{this.off(t,n);}}off(t,n){return this.subscribers[t]=(this.subscribers[t]||[]).filter(r=>n&&r!==n),this}removeAllListeners(){return this.subscribers={},this}};function Ea(){let e=K().emitter;return e||(e=new C,K().emitter=e),e}function Pa(e,t){let n=Math.round(S()*100),r=[],o,i=(a,s)=>{let c={key:a,obj:s};r.push(c),o&&o();};return t?e.on?e.on(t,a=>{i(t,a);}):e.addEventListener?e.addEventListener(t,a=>{i(t,a);}):e.log.error(n,"Cannot listen to key"):e.onAny?e.onAny((a,s)=>{i(a,s);}):e.log.error(n,"cannot listen to all for",e),(a,s=!0)=>new Promise((c,g)=>{a||(a=t,a||r.length&&(a=r[0].key)),o=()=>{for(;r.length>0;){let l=r.shift();if(l.key===a)o=void 0,c(l.obj);else {if(s)continue;g(new Error(`Expected ${a}, but found ${l.key} with value=${l.obj}`));}break}},o();})}var ie=()=>Date.now();function zt(e){return e>999?`${(e/1e3).toFixed(1)}s`:`${e.toFixed(2)}ms`}function Sa(...e){for(let t of e){if(t instanceof Date)return t;if(typeof t=="string"){let n=null;if(t.includes(":"))try{n=new Date(t);}catch{}if(!(n instanceof Date)){let r=/(\d\d\d\d)-(\d\d)-(\d\d)/.exec(t);r&&(n=new Date(+r[1],+r[2]-1,+r[3],12,0));}if(n instanceof Date)return n}}}var xe=16;function Ne(){return Q(xe)}function ur(e=Ne()){return Ce(e,22)}function cr(e){return Ce(e,22)}function lr(e){return bt(e,xe)}function fr(e=Ne()){return ke(e,26)}function dr(e){return ke(e,26)}function pr(e){return xt(e,xe)}var gr="10000000-1000-4000-8000-100000000000",mr=function(){return typeof crypto<"u"&&crypto.randomUUID!=null?crypto.randomUUID():gr.replace(/[018]/g,e=>(e^Q(1)[0]&15>>e/4).toString(16))};function yr(e){let t=st(e);return `${t.slice(0,8)}-${t.slice(8,12)}-${t.slice(12,16)}-${t.slice(16)}`}function hr(e){return at(e.replaceAll("-",""))}var Vt=16e11;function xr(e){let t=new Uint8Array([0,0,0,0,0,0]),n=t.length-1;for(let r=0;r<t.length;r++){let o=e&255;t[n-r]=o,e=(e-o)/256;}return t}function qt(){let e=ie()-Vt;return new Uint8Array([...xr(e),...Q(10)])}function Ca(){return Tr(qt())}function Ia(e){return br(Jt(e))}function br(e){return new Date(Vt+e.slice(0,6).reduce((t,n)=>t*256+n,0))}function $a(){return new Uint32Array(Q(4))[0]}var He={base62:{uuid:ur,uuidDecode:lr,uuidEncode:cr},base32:{uuid:fr,uuidDecode:pr,uuidEncode:dr},uuidv4:{uuid:mr,uuidDecode:hr,uuidEncode:yr}},be="base62",Wt=!1;function Oa(e,t=!1){be=e,Wt=t;}function J(){return He[be].uuid(Wt?qt():Ne())}function Jt(e){return He[be].uuidDecode(e)}function Tr(e){return He[be].uuidEncode(e)}function Ba(e){try{return Jt(e).length===xe}catch{}return !1}var je={};function B(e="id"){return je[e]==null&&(je[e]=0),`${e}-${je[e]++}`}var wr=0;function _a(){return `id-${wr++}`}var Ge=class extends C{constructor(){super(...arguments);this.id=J();}close(){this.dispose();}},Te=class extends Ge{constructor(){super(...arguments);this.isConnected=!0;}postMessage(n){this.other?.emit("message",{data:n,origin:"local",lastEventId:J()});}};function Ga(){let e=new Te,t=new Te;return e.other=t,t.other=e,[e,t]}var Zt=class{async encode(t){return t}async decode(t){return t}},ne=class{async encode(t){return Pe(t)}async decode(t){return De(t)}},Kt=class{constructor(t){this.key=t;}async encode(t){let n=Pe(t);return await gt(n,this.key)}async decode(t){let n=await mt(t,this.key);return De(n)}};var Yt=(e,t,n={})=>new Proxy(n,{get:(r,o)=>o in r?r[o]:(...i)=>e(o,i,t)});function Xa(e={}){let{name:t=B("hub"),encoder:n=new ne,retryAfter:r=1e3,ignoreUnhandled:o=!0,logLevel:i=!1}=e,u=U(t,i),a={},s,c=[],g,l={},f=()=>{clearTimeout(g);},p=async()=>{if(clearTimeout(g),s){if(s.isConnected)for(;c.length;){let y=c[0];try{s.postMessage(await n.encode(y)),c.shift();}catch(w){u.warn("postMessage",w);break}}c.length>0&&r>0&&(g=setTimeout(p,r));}},d=async y=>{u("enqueue postMessage",y),c.push(y),await p();},m=async y=>{s=y,s.on("connect",p),s.on("message",async w=>{u("onmessage",typeof w);let{name:A,args:P,id:h,result:x,error:L}=await n.decode(w.data);if(A){u(`name ${A} id ${h}`);try{if(a[A]==null)throw new Error(`handler for ${A} was not found`);let E=a[A](...P);k(E)&&(E=await E),u(`result ${E}`),h&&await d({id:h,result:E});}catch(E){let T=E instanceof Error?E:new Error(Ie(E));u.warn("execution error",T.name),await d({id:h,error:{message:T.message,stack:T.stack,name:T.name}});}}else if(h)if(u(`response for id=${h}: result=${x}, error=${L}`),l[h]==null)x===void 0?u(`skip response for ${h}`):u.warn(`no response hook for ${h}`);else {let[E,T]=l[h];if(E&&T)if(delete l[h],L){let D=new Error(L.message);D.stack=L.stack,D.name=L.name,u.warn("reject",D.name),T(D);}else u("resolve",x),E(x);}else o||u.warn("Unhandled message",w);}),await p();},b=async(y,w,A={})=>{let{timeout:P=5e3}=A,h=J();return await d({name:y,args:w,id:h}),St(new Promise((x,L)=>l[h]=[x,L]),P)};return e.channel&&m(e.channel),{dispose:f,connect:m,listen(y){Object.assign(a,y);},send(){return Yt(b,{},{options(y){return Yt(b,{...y})}})}}}var ze=class extends C{constructor(n){super();this.publish=this.emit.bind(this);this.subscribe=this.on.bind(this);let{name:r,encoder:o=new ne,channel:i,debug:u=!1}=n;this.channel=i,this.encoder=o,this.debug=u,this.name=r??this.channel.id??B("pubsub"),this.log=U(`${this.shortId}`),this.debug&&(this.channel.on("connect",()=>{this.log("channel connected");}),this.channel.on("disconnect",()=>{this.log("channel disconnected");})),this.channel.on("message",async({data:a})=>{let s=await this.encoder.decode(a);if(this.debug?this.log(`channel message, event=${s?.event}, info=`,s):this.log(`channel message, event=${s?.event}`),s){let{event:c,args:g}=s;await this.emitSuper(c,...g);}});}get shortId(){return this.name.substr(0,6)}async emitSuper(n,...r){return await super.emit(n,...r)}async emit(n,...r){try{if(this.debug?this.log(`emit(${String(n)})`,n):this.log(`emit(${String(n)})`,r.length),!this.channel.isConnected)return this.log.warn("channel not connected"),!1;let o=await this.encoder.encode({event:n,args:r});return this.channel.postMessage(o),!0}catch(o){this.log.warn(`emit(${String(n)})`,o);}return !1}};function iu(e){return new ze(e)}var Lr=1;var Qt=e=>e,vr=Qt;function au(e,t){let{post:n,on:r,eventNames:o=[],serialize:i=Qt,deserialize:u=vr}=t,a=new Map;return r(async s=>{let c=u(s),[g,l,f,p]=c;if(g===1||g===2){let d,m;if(p!=null)try{let b=e[p];d=await b(...l);}catch(b){m=String(b);}else m="Method implementation missing";g===1&&f&&n(i(m?[4,m,f]:[3,d,f]));}else if(f){let d=a.get(f);d!=null&&(g===4?d.reject(l):d.resolve(l)),a.delete(f);}}),new Proxy({},{get(s,c){let g=(...f)=>{n(i([2,f,null,c]));};if(t.onlyEvents||o.includes(c))return g.asEvent=g,g;let l=(...f)=>new Promise((p,d)=>{let m=Lr++;a.set(m,{resolve:p,reject:d}),n(i([1,f,m,c]));});return l.asEvent=g,l}})}var Z=class extends C{constructor(n={}){super();this._isCancelled=!1;this._resetWhenFinished=!0;this._children=[];this._totalUnits=n.totalUnits??0,this._completedUnits=n.completeUnits??0,this._resetWhenFinished=n.resetWhenFinished??!0,this.name=n.name??B("progress"),this.dispose.add(async()=>{for(let r of this._children)await r.dispose();await this.emit("progressDispose",this);});}update(){this.emit("progressChanged",this),this._isCancelled&&this._resetWhenFinished&&this.getTotalUnits()<=this.getCompletedUnits()&&this.reset();}reset(){if(this._isCancelled){this._isCancelled=!1;for(let n of this._children)n.reset();this.update();}}async cancel(){if(!this._isCancelled){this._isCancelled=!0,await this.emit("progressCancelled",this);for(let n of this._children)await n.cancel();this.update();}}addChild(n){n.on("progressDispose",()=>this.removeChild(n)),n.on("progressChanged",()=>this.update()),this._children.includes(n)||this._children.push(n),this.update();}createChildProgress(n){let r=new Z(n);return this.addChild(r),r}removeChild(n){yt(this._children,n),this.update();}getTotalUnits(){if(this.isIndeterminate())return 0;let n=this._totalUnits;for(let r of this._children)n+=r.getTotalUnits();return n}getCompletedUnits(){if(this.isIndeterminate())return 0;let n=this._completedUnits;for(let r of this._children)n+=r.getCompletedUnits();return n}isIndeterminate(){return this._totalUnits<=0&&this._children.length<=0}isCancelled(){return this._isCancelled}isFinished(){return this.dispose.isDisposed()||!this.isIndeterminate()&&this.getTotalUnits()<=this.getCompletedUnits()}getFraction(){if(this.isIndeterminate())return 0;let n=this.getCompletedUnits()/this.getTotalUnits();return isNaN(n)&&(n=0),Math.min(1,Math.max(0,n))}getChildrenCount(){return this._children.length}setTotalUnits(n,r){this._totalUnits=n,r!=null&&(this._completedUnits=r),this.update();}incTotalUnits(n=1){this._totalUnits+=n,this.update();}setCompletetedUnits(n){this._completedUnits=n,this.update();}setCompleted(){this._completedUnits=this._totalUnits,this.update();}incCompletedUnits(n=1){this._completedUnits+=n,this.update();}toString(n=0){let r=`${"  ".repeat(n)}${this.name}: ${this._completedUnits} of ${this._totalUnits} units, ${Math.floor(this.getFraction()*100)} %, cancel=${this._isCancelled}
`;for(let o of this._children)r+=o.toString(n+1);return n===0?r.trim():r}};function xu(e={}){let{maxParallel:t=3,name:n=B("pool"),idConflictResolution:r="memoize"}=e,o=new C,i=oe();i.add(w);let u=new Z({name:n});u.on("progressCancelled",w);let a=0,s=0,c=0,g=0,l={};async function f(){if(a>0){let[h,x]=Dt();return o.once("didFinish",x),h}}async function p(){for(let h of Object.keys(l))l[h].state==="finished"&&(await l[h].progress.dispose(),delete l[h]);}function d(){o.emit("didFinish"),a=0,s=0,p(),u.reset();}function m(){let h=0,x=0;for(let{max:L,resolved:E,state:T}of Object.values(l))h+=L,x+=T==="finished"?L:Math.min(L,E);o.emit("didUpdate",a,s,h,x);}function b(){if(m(),a>0&&a===s&&d(),c>=t)return;let h=Object.values(l).filter(x=>x.state==="waiting");if(h.length>0){let x;for(let L of h)L.group!=null&&Object.values(l).some(E=>E.state==="running"&&E.id!==L.id&&E.group===L.group)||(x==null||L.priority<x.priority)&&(x=L);if(x!=null){let L=x.id,E=x.done;x.state="running",++c,o.emit("didStart",L);let T=D=>{x&&(x.result=D,x.state="finished",x.resolved=x.max,x.progress?.setCompleted()),--c,++s,b();};x.task(x).then(D=>{E(D),o.emit("didResolve",L,D),T(D);}).catch(D=>{E(),o.emit("didReject",L,D),T();});}}}function y(h){let x=l[h];x&&x.state==="waiting"&&(l[h].state="finished",++s,o.emit("didCancel",h),l[h].progress.dispose(),m());}function w(){Object.keys(l).forEach(y);}function A(h){return l[h]!=null}function P(h,x={}){let L,E=new Promise(R=>L=R),T=x.id??J();if(l[T]!=null){let R=x.idConflictResolution??r;if(R==="replace")y(T);else if(R==="memoize"||R==="prioritize"){let Xe=l[T];return R==="prioritize"&&(Xe.priority=++g),{id:T,promise:(async()=>{if(Xe.state==="finished")return l[T].result})(),dispose:()=>y(T),cancel:()=>y(T)}}else throw new Error(`Pool task with id=${T} already exists!`)}let D=new Z({name:T,totalUnits:x.max??1,completeUnits:x.resolved??0});return u.addChild(D),l[T]={id:T,task:h,priority:++g,group:x.group,state:"waiting",max:x.max??1,resolved:x.resolved??0,done:L,payload:x.payload,progress:D,setMax(R){D.setTotalUnits(R),l[T].max=R,m();},setResolved(R){D.setCompletetedUnits(R),l[T].resolved=R,m();},incResolved(R=1){D.incCompletedUnits(R),l[T].resolved+=R,m();}},++a,b(),{id:T,promise:E,dispose:()=>y(T),cancel:()=>y(T)}}return {events:o,cancel:y,cancelAll:w,hasById:A,progress:u,enqueue:P,dispose:i,waitFinishAll:f}}var Xt=class extends C{constructor(n={}){super();this.queue=[];this.waitToFinish=[];this.countMax=0;this.countResolved=0;this.paused=!1;let{name:r=B("queue"),logLevel:o}=n;this.name=r,this.log=U(`zeed:queue:${r}`,o??Y);}async performNext(){if(this.log("performNext, queue.length =",this.queue.length),this.currentTask!=null){this.log("performNext => skip while another task is running");return}if(this.paused){this.log("performNext => skip while is paused");return}for(;this.currentTask==null&&!this.paused;){let n=this.queue.shift();if(this.log(`performNext => ${n?.name}`),n==null)break;this.countResolved===0&&this.emit("didStart",this.countMax);let{name:r,task:o,resolve:i}=n;this.currentTask=o();let u;try{this.log.info(`start task ${r}`),u=await this.currentTask,this.log(`finished task ${r} with result =`,u);}catch(a){this.log.warn("Error performing task",a);}i(u),this.currentTask=void 0,this.countResolved+=1,this.emit("didUpdate",this.countMax,this.countResolved);}for(this.queue.length===0&&(this.emit("didFinish"),this.countMax=0,this.countResolved=0);this.waitToFinish.length>0;)this.waitToFinish.shift()();}async enqueue(n,r={}){let{immediate:o=!1,name:i=B(this.name)}=r;return o?(this.log.info(`immediate execution ${i}`),await n()):(this.log(`enqueue ${i}`),new Promise(u=>{this.queue.push({name:i,task:n,resolve:u}),this.countMax+=1,this.emit("didUpdate",this.countMax,this.countResolved),this.performNext();}))}async enqueueReentrant(n,r={}){return this.enqueue(n,{immediate:this.currentTask!=null,name:r.name})}async cancelAll(n=!0){this.log("cancelAll"),this.emit("didCancel");let r=this.queue.map(o=>o.resolve);this.queue=[],r.forEach(o=>o(void 0)),await this.wait();}async pause(){this.log("pause"),this.paused=!0,await this.wait();}resume(){this.log("resume"),this.paused=!1,this.performNext();}async wait(){if(this.log("wait"),!(this.currentTask==null&&(this.queue.length===0||this.paused)))return new Promise(n=>{this.waitToFinish.push(n);})}get isPaused(){return this.paused}get hasTasks(){return this.queue.length!==0}};function Pu(e,t={}){let {delay:n=100,trailing:r=!0,leading:o=!0}=t,i=0,u=0,a=0,s;function g(){return i?(clearTimeout(i),i=void 0,!0):!1}function l(...f){let p=Date.now(),d=p-u,m=()=>{a=0,u=Date.now(),e.apply(this,f);};if(s=m,d>n||!i){o&&(d>n?m():++a);let b=d>n?n:n-d;g(),u=p,i=setTimeout(()=>{i=0,r&&(!o||a>0)&&s?.();},b);}else ++a;}return l.cancel=g,l.stop=()=>{g()&&s&&s();},l.immediate=async function(...p){g(),u=Date.now(),e.apply(this,p);},l.dispose=()=>l.stop(),l}function Du(e,t={}){let{delay:n=100}=t,r=0,o=!1,i;function u(){r&&(clearTimeout(r),r=0);}async function a(){try{if(u(),i!=null){let g=[...i];i=void 0,o=!0,await N(e(...g)),o=!1,i!=null&&(u(),r=setTimeout(a,n));}}catch{}}function s(...g){i=[...g],u(),o===!1&&(r=setTimeout(a,n));}async function c(...g){u(),i=[...g],await a();}return s.cancel=u,s.dispose=u,s.immediate=c,s}function Ru(e=globalThis?.location?.hostname??""){return ["::ffff:127.0.0.1","localhost","127.0.0.1","","::1","::"].includes(e)||e.startsWith("192.168.")||e.startsWith("10.0.")||e.endsWith(".local")}function Fu(e){let{level:t=void 0,filter:n=void 0,messages:r=[]}=e,o=_(n),i=z(t);return u=>{i(u.level)&&o(u.name)&&r.push(u);}}var Ve={cache:"no-cache",redirect:"follow",headers:{}};function Ar(e){let t=/:\/\/([^@]*)@/gi.exec(e);if(t&&t[1]){let[n,r]=t[1].split(":",2);return {url:e.replace(`${t[1]}@`,""),username:n,password:r}}}async function en(e,t={},n=fetch){try{G(t)&&(t=he({},...X(t)));let r=Ar(String(e));r&&(e=r.url,t=he({},t,Er(r.username,r.password))),t.headers!=null&&!(t.headers instanceof Headers)&&(t.headers=new Headers(t.headers));let o=await n(String(e),t);if(o.status<400)return o;let i=U("zeed:network");try{i.warn(`Fetch of ${String(e)} returned status=${o.status}. Options:`,t),i.warn(`Response: ${await o.text()}`);}catch(u){i.error("Exception:",u);}}catch(r){U("zeed:network").error("fetchBasic",r);}}async function Ou(e,t={},n=fetch){try{let r=await en(e,[{method:"GET",headers:{Accept:"application/json"}},t],n);if(r)return await r.json()}catch(r){U("zeed:network").error("fetchJSON error:",r);}}async function Bu(e,t={},n=fetch){try{let r=await en(e,[Ve,{method:"GET"},t],n);if(r)return await r.text()}catch(r){U("zeed:network").error("fetchHTML error:",r);}}function _u(e,t="POST"){return {method:t,...Ve,headers:{"Content-Type":"application/x-www-form-urlencoded; charset=utf-8"},body:Nt(e)}}function ju(e,t="POST"){return {method:t,...Ve,headers:{"Content-Type":"application/json; charset=utf-8"},body:M(e)}}function Er(e,t){return {headers:{Authorization:`Basic ${ut(`${e}:${t}`)}`}}}function tn(){if(typeof window<"u")return window}function Pr(){if(typeof navigator<"u")return navigator}function Hu(){return tn()??typeof WorkerGlobalScope<"u"?self:typeof global<"u"?global:Function("return this;")()}function Gu(e={ios:!1,macos:!1,windows:!1,beaker:!1,electron:!1,wkwebview:!1,pwa:!1,pwaInstalled:!1,browser:!1,node:!1,worker:!1,test:!1,jest:!1,macosNative:!1,iosNative:!1,appleNative:!1,touch:!1}){let t=Pr(),n=tn();return e.ios=t?.platform?.match(/(iPhone|iPod|iPad)/i)!=null,e.macos=!!t?.platform?.startsWith("Mac"),e.windows=!!t?.platform?.startsWith("Win"),e.beaker=n?.beaker!=null,e.electron=(t?.userAgent?.toLowerCase()?.indexOf(" electron/")||-1)>-1&&!e.beaker,e.wkwebview=n?.webkit?.messageHandlers!=null,e.pwa=t?.serviceWorker!=null,e.pwaInstalled=t?.standalone||n?.matchMedia?.("(display-mode: standalone)")?.matches,e.node=typeof process<"u"&&process?.release?.name==="node",e.browser=!e.electron&&!e.wkwebview&&!e.node,e.worker=typeof WorkerGlobalScope<"u"&&self instanceof WorkerGlobalScope,e.jest=typeof jest<"u"||typeof vitest<"u",e.test=e.jest,e.macosNative=e.wkwebview&&e.macos,e.iosNative=e.wkwebview&&e.ios,e.appleNative=e.wkwebview,e.touch=n&&"ontouchstart"in n||(t?.maxTouchPoints||0)>1||t?.msPointerEnabled&&n?.MSGesture||n?.DocumentTouch&&document instanceof DocumentTouch,e}function Dr(){return typeof window<"u"&&globalThis===window}function zu(e){Dr()?window.addEventListener("beforeunload",e):typeof process<"u"&&process.on("exit",()=>e);}var nn=class{constructor(t={}){this.store={};}setItem(t,n){this.store[t]=te(n);}getItem(t){return te(this.store[t])}removeItem(t){delete this.store[t];}clear(){this.store={};}allKeys(){return Object.keys(this.store)}};var Ju=()=>{};function Yu(e={}){let{args:t=process.argv.slice(1),alias:n={},normalize:r=Tt,booleanArgs:o=[],listArgs:i=[],numberArgs:u=[]}=e,a=Object.entries(n).reduce((f,p)=>{let[d,m]=p;typeof m=="string"&&(m=[m]);for(let b of m)f[r(b)]=r(d);return f},{}),s={_:[]};function c(f,p){s[f]==null||typeof s[f]=="boolean"?s[f]=p:Array.isArray(s[f])?s[f].push(p):s[f]=[s[f],p];}let g=[...t],l;for(;l=g.shift();){let f;if(/^--?/.test(l)){let p=l.replace(/^--?/,"");if(l.includes("=")){let[d,m]=p.split("=",2);p=d.trim(),f=m.trim();}p=r(p),p=a[p]??p,o.includes(p)?c(p,!0):(f=f??g.shift()??"",u.includes(p)&&(f=Number(f??0)),i.includes(p)?Array.isArray(s[p])?s[p].push(f):s[p]=[f]:c(p,f));}else s._.push(l);}return s}function Xu(e){return new Promise((t,n)=>{import('child_process').then(({spawn:r})=>{let o=r("pbcopy");o.on("error",i=>n(i)),o.on("close",()=>t(e)),o.stdin.write(e),o.stdin.end();}).catch(()=>{});})}function nc(){try{typeof globalThis<"u"&&typeof globalThis.crypto>"u"&&qe__default.default&&qe__default.default.webcrypto&&(globalThis.crypto=qe__default.default.webcrypto);}catch(e){console.warn("Failed to polyfill webcrypto",e);}}async function rc(){if(globalThis.crypto==null)try{if(typeof globalThis<"u"&&typeof globalThis.crypto>"u"){let e=await import('crypto');globalThis.crypto=e.webcrypto;}}catch(e){console.warn("Failed to polyfill webcrypto",e);}return globalThis.crypto}var Rr=`
`,Ur=/^\s*([\w_.-]+)\s*=\s*(.*)?\s*$/,Mr=/\\n/g,Fr=/\n|\r|\r\n/;function rn(e,t={}){let n={};return String(e).split(Fr).forEach((r,o)=>{let i=r.match(Ur);if(i!=null){let u=i[1],a=i[2]||"",s=a.length-1,c=a[0]==='"'&&a[s]==='"';a[0]==="'"&&a[s]==="'"||c?(a=a.substring(1,s),c&&(a=a.replace(Mr,Rr))):a=a.trim(),n[u]=a;}}),n}function kr(e,t="."){return path.resolve(process.cwd(),e??t)}function Cr(e,t=""){return e==null&&(e=t),kr(String(e).trim(),t)}var We=Cr;function ac(e,t=process.env){if(t[e]!=null)return t[e];e=e.toLowerCase();for(let[n,r]of Object.entries(t))if(n.toLowerCase()===e)return r}function uc(e={}){let t=e?.path??We(e?.filename??".env"),n=e?.encoding??"utf8",r=e?.debug||!1;try{let o=we__default.default.existsSync(t)?rn(we__default.default.readFileSync(t,{encoding:n}),{debug:r}):{},i=we__default.default.existsSync(`${t}.local`)?rn(we__default.default.readFileSync(`${t}.local`,{encoding:n}),{debug:r}):{},u=Object.assign({},o,i),a=e?.env??process.env;return Object.entries(u).forEach(([s,c])=>{typeof e?.prefix=="string"&&(s=e?.prefix+s),Object.prototype.hasOwnProperty.call(a,s)||c!=null&&(a[s]=c);}),{parsed:u}}catch(o){return {error:o}}}var an=class{constructor(t={}){this.store={};this.fileKeys=void 0;this.pretty=!1;this.dirname=path.resolve(process.cwd(),t.path??".fileStorage"),this.pretty=!!t.pretty,this.extension=t.extension??".json",t.extension&&!this.extension.startsWith(".")&&(this.extension=`.${this.extension}`),this.extensionLength=this.extension.length,this.objectToString=t.objectToString??(n=>this.pretty?M(n,null,2):M(n)),this.objectFromString=t.objectFromString??(n=>{try{return JSON.parse(n)}catch{}}),this.keyToFilename=t.keyToFilename??$t;}setItem(t,n){this.store[t]=te(n);try{let r=this.objectToString(n),o=this.getPath(t);we.mkdirSync(path.dirname(o),{recursive:!0}),we.writeFileSync(o,r,"utf8");}catch{}}getPath(t){return path.resolve(this.dirname,this.keyToFilename(t)+this.extension)}getBuffer(t){let n=this.getPath(t);return Buffer.from(we.readFileSync(n))}getItem(t){let n=this.store[t];if(n!==null){if(n!=null)return te(n);try{let r=this.getPath(t),o=we.readFileSync(r,"utf8");if(o!=null){let i=this.objectFromString(o);return this.store[t]=i,i}}catch{this.store[t]=null;}}}removeItem(t){if(delete this.store[t],this.fileKeys!=null){let n=this.fileKeys.indexOf(t);n!==-1&&this.fileKeys.splice(n,1);}try{let n=this.getPath(t);we.unlinkSync(n);}catch{}}clear(){this.fileKeys=[],this.store={},we.rmSync(this.dirname,{recursive:!0,force:!0});}allKeys(){if(this.fileKeys==null)try{this.fileKeys=we.readdirSync(this.dirname,{withFileTypes:!0}).filter(n=>!n.isDirectory()&&n.name.endsWith(this.extension)).map(n=>n.name.slice(0,-this.extensionLength))||[];}catch{}let t=[...this.fileKeys||[]];for(let n of Object.keys(this.store))t.includes(n)||t.push(n);return t.sort(),t}};function xc(e){let t=path.normalize(e),n=process.env.HOME;return n&&t.startsWith(n)?`~${t.slice(n.length)}`:t}async function Ze(e){try{await promises.stat(e);}catch{return !1}return !0}async function bc(...e){let t=path.join(...e);return await Ze(t)||await promises.mkdir(t,{recursive:!0}),t}async function Tc(...e){let t=path.join(...e);return await Ze(t)&&await promises.rm(t,{recursive:!0}),t}async function wc(...e){let t=path.join(...e);if(await Ze(t))return await promises.readFile(t,"utf-8")}async function Lc(e,t){await promises.writeFile(e,t,"utf-8");}var un={};function cn(e,t={}){let{level:n=void 0,filter:r=void 0,time:o=!0,pretty:i=!1}=t;e=path.resolve(process.cwd(),e),we.mkdirSync(path.dirname(e),{recursive:!0});let u=we.createWriteStream(e,{flags:"a"}),a=_(r),s=z(n);return c=>{if(!s(c.level)||!a(c.name))return;let g=o?`${new Date().toISOString()} `:"",l=c.name||"",f=un[l||""];f==null&&(un[l]=f);let p=[`[${l||"*"}]`,pe(c.messages,{pretty:i})];function d(...m){u.write(`${m.join("	")}
`);}switch(c.level){case O:d(`${g}I|*  `,...p);break;case I:d(`${g}W|** `,...p);break;case $:d(`${g}E|***`,...p);break;default:d(`${g}D|   `,...p);break}}}function Yr(e){return typeof e!="string"?[]:e?.split(`
`).map(t=>{let n=t.match(/^\s+at.*(\((.*)\)|file:\/\/(.*)$)|\s*at\s(\/.*)$/);if(n){let r=n[3]||n[2]||n[4];return r.endsWith(")")&&(r=r.slice(0,-1)),r}})?.filter(Ft)??[]}function fn(e){if(e.includes("/node_modules/"))return "";let t="file://";if(e.startsWith(t))return e.substr(t.length);let n=path.resolve(process.cwd());if(n&&e.startsWith(n))return e.substr(n.length+1);let r=process.env?.HOME?path.resolve(process.env?.HOME):"";return r&&e.startsWith(r)&&(e=`~/${e.substr(r.length+1)}`),e}function Qr(e){let t=e.match(/^\s*at.*(\((.*)\)|file:\/\/(.*)$)|\s*at\s(\/.*)$/);if(t){let n=t[3]||t[2]||t[4];return n.endsWith(")")&&(n=n.slice(0,-1)),n}return ""}function Ke(e=2,t=!0){let n=new Error("stack").stack||"",r=Yr(n)?.[e];return r&&t&&(r=fn(r)),r||""}function dn(){return new Error("stack").stack||""}function pn(e,t=!0){let n="",r=new Error("stack").stack||"";if(typeof r=="string"){let o=r.split(`
`).map(u=>u.trim()),i=o.findIndex(u=>e.some(a=>u.startsWith(a)));n=o[i+1],n&&(n=Qr(n)),n&&t&&(n=fn(n));}return n}function eo(){try{return ee(process.env.ZEED_COLOR,Xr__default.default.isatty(process.stdout.fd))}catch{}return !1}var Ye,gn=[6,2,3,4,5,1];function to(e){let t=0;for(let n=0;n<e.length;n++)t=(t<<5)-t+e.charCodeAt(n),t|=0;return gn[Math.abs(t)%gn.length]}var mn={},Qe;function Le(...e){process.stdout.write(`${pe(e)}
`);}var ae={BOLD:"\x1B[1m",UNBOLD:"\x1B[2m",RED:"\x1B[31m",GREEN:"\x1B[32m",BLUE:"\x1B[34m",PURPLE:"\x1B[35m",GRAY:"\x1B[37m",ORANGE:"\x1B[38;5;208m",UNCOLOR:"\x1B[0m"};var hn="\x1B[0m";function se(e,t){return `${t===8?ae.ORANGE:`\x1B[3${t<8?t:`8;5;${t}`}m`}${e}${hn}`}function yn(e,t,n=!0){return e.map(r=>{if(typeof r!="string")return r;let o=t,i=hn;return n&&(o=`${ae.BOLD}${o}`,i=`${i}${ae.BOLD}`),`${o}${r}${i}`})}var no="loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";function xn(e={}){Ye==null&&(Ye=eo()),Qe==null&&(Qe=ie());let{level:t=void 0,filter:n=void 0,colors:r=Ye,levelHelper:o=!0,nameBrackets:i=!0,padding:u=0,fill:a=0,stack:s=!0,time:c=!0}=e,g=_(n),l=z(t);return f=>{if(!l(f.level)||!g(f.name))return;let p=ie(),d=f.name||"",m=mn[d||""];m==null&&(m={color:to(d)},mn[d]=m);let b=zt(p-Qe),y,w=i?`[${d}]`:d;if(u>0&&(w=w.padStart(u," ")),a>0&&(w=w.padEnd(a," ")),r){let h=m.color;y=[`${se(w,h)} | `],f.level===I?y.push(...yn(f.messages,ae.ORANGE)):f.level===$?y.push(...yn(f.messages,ae.RED)):y.push(...f.messages),c&&y.push(se(`+${b}`,h));}else y=[w,...f.messages],c&&y.push(`+${b}`);if(f.messages?.[0]===no&&console.log(dn()),s){let h="";typeof s=="boolean"?(h=pn(["at Function.","at null.log (","at log ("],!0),h||(h=Ke(0,!0))):h=Ke(typeof s=="number"?s:3,!0),h&&y.push(se(`(${h})`,7));}let A="|",P=".";switch(f.level){case O:o&&(y[0]=`I${A}${P}   ${y[0]}`),Le(...y);break;case I:o&&(y[0]=(r?se(`W${A}${P}${P}  `,8):`W${A}${P}${P}  `)+y[0]),Le(...y);break;case $:o&&(y[0]=(r?se(`E${A}${P}${P}${P} `,1):`E${A}${P}${P}${P} `)+y[0]),Le(...y);break;default:o&&(y[0]=`D${A}    ${y[0]}`),Le(...y);break}}}function ro(e,t){return Ee(n=>{let r=[xn({padding:32,nameBrackets:!1})],o=process.env.ZEED_LOG??process.env.LOG,i=ee(process.env.ZEED_TIME,!0),u=ee(process.env.ZEED_PRETTY,!1);o&&r.unshift(cn(We(o),{time:i,pretty:u})),n.setHandlers(r);})(e,t)}

exports.CRYPTO_DEFAULT_ALG = Se;
exports.CRYPTO_DEFAULT_DERIVE_ALG = ft;
exports.CRYPTO_DEFAULT_DERIVE_ITERATIONS = Sn;
exports.CRYPTO_DEFAULT_HASH_ALG = dt;
exports.Channel = Ge;
exports.CryptoEncoder = Kt;
exports.DAY_MS = Lt;
exports.Day = v;
exports.DefaultLogger = U;
exports.Emitter = C;
exports.FileStorage = an;
exports.JsonEncoder = ne;
exports.LocalChannel = Te;
exports.LogLevelAlias = et;
exports.LogLevelAll = V;
exports.LogLevelDebug = W;
exports.LogLevelError = $;
exports.LogLevelFatal = ce;
exports.LogLevelInfo = O;
exports.LogLevelOff = Y;
exports.LogLevelWarn = I;
exports.Logger = ro;
exports.LoggerConsoleHandler = ue;
exports.LoggerContext = tt;
exports.LoggerFileHandler = cn;
exports.LoggerMemoryHandler = Fu;
exports.LoggerNodeHandler = xn;
exports.MemStorage = nn;
exports.NoopEncoder = Zt;
exports.Progress = Z;
exports.PubSub = ze;
exports.SerialQueue = Xt;
exports.Uint8ArrayToHexDump = lt;
exports.Uint8ArrayToJson = De;
exports.Uint8ArrayToString = it;
exports.XRX = Gt;
exports._decodeUtf8Polyfill = Pn;
exports._encodeUtf8Polyfill = En;
exports._useBase = Bn;
exports.arrayAvg = oi;
exports.arrayBatches = ii;
exports.arrayEmptyInPlace = Ko;
exports.arrayFilterInPlace = Fe;
exports.arrayFlatten = X;
exports.arrayIntersection = Cn;
exports.arrayIsEqual = $n;
exports.arrayMax = ti;
exports.arrayMin = ni;
exports.arrayMinus = Fn;
exports.arrayRandomElement = ei;
exports.arrayRemoveElement = yt;
exports.arraySetElement = Jo;
exports.arrayShuffle = Qo;
exports.arrayShuffleForce = Xo;
exports.arrayShuffleInPlace = ht;
exports.arraySorted = In;
exports.arraySortedNumbers = Yo;
exports.arraySum = ri;
exports.arraySymmetricDifference = Wo;
exports.arrayToggleInPlace = Zo;
exports.arrayUnion = kn;
exports.arrayUnique = Me;
exports.assert = bo;
exports.avg = Oo;
exports.between = $o;
exports.cloneJsonObject = Zs;
exports.cloneObject = te;
exports.cmp = Ue;
exports.colorString = se;
exports.colorStringList = yn;
exports.composeOrderby = Ho;
exports.createArray = si;
exports.createLocalChannelPair = Ga;
exports.createPromise = Dt;
exports.createPromiseProxy = Yt;
exports.csvParse = sr;
exports.csvParseToObjects = oa;
exports.csvStringify = ra;
exports.dateStringToDays = Ji;
exports.day = Wi;
exports.dayDay = Gn;
exports.dayDiff = Ci;
exports.dayFromAny = Ri;
exports.dayFromDate = me;
exports.dayFromDateGMT = Mi;
exports.dayFromParts = Be;
exports.dayFromString = Pt;
exports.dayFromTimestamp = zn;
exports.dayFromToday = Et;
exports.dayIterator = $i;
exports.dayMonth = vt;
exports.dayMonthStart = Fi;
exports.dayOffset = ge;
exports.dayRange = Ii;
exports.dayToDate = At;
exports.dayToDateGMT = Ui;
exports.dayToParts = Si;
exports.dayToString = Vn;
exports.dayToTimestamp = $e;
exports.dayYear = Oe;
exports.dayYearStart = ki;
exports.debounce = Du;
exports.decimal = qn;
exports.decimalCentsPart = Qi;
exports.decimalFromCents = Ki;
exports.decimalToCents = Yi;
exports.decodeBase16 = li;
exports.decodeBase32 = xt;
exports.decodeBase58 = di;
exports.decodeBase62 = bt;
exports.decrypt = mt;
exports.deepEqual = Wn;
exports.deepMerge = he;
exports.deepStripUndefinedInPlace = Jn;
exports.deriveKeyPbkdf2 = Mo;
exports.detect = Gu;
exports.digest = Uo;
exports.empty = Js;
exports.encodeBase16 = ci;
exports.encodeBase32 = ke;
exports.encodeBase58 = fi;
exports.encodeBase62 = Ce;
exports.encodeQuery = Nt;
exports.encrypt = gt;
exports.endSortWeight = jt;
exports.ensureFolder = bc;
exports.ensureKey = zs;
exports.ensureKeyAsync = Vs;
exports.equalBinary = ct;
exports.escapeHTML = kt;
exports.escapeRegExp = Ot;
exports.estimateSizeForBase = pi;
exports.exists = Ze;
exports.fatal = vn;
exports.fetchBasic = en;
exports.fetchJson = Ou;
exports.fetchOptionsBasicAuth = Er;
exports.fetchOptionsFormURLEncoded = _u;
exports.fetchOptionsJson = ju;
exports.fetchText = Bu;
exports.fixBrokenUth8String = Pi;
exports.forEachDay = Vi;
exports.forTimes = Qs;
exports.formatMessages = Hn;
exports.formatMilliseconds = zt;
exports.fromBase64 = Dn;
exports.fromBase64String = Do;
exports.fromCamelCase = yi;
exports.fromHex = at;
exports.getEnvVariableRelaxed = ac;
exports.getGlobal = Hu;
exports.getGlobalContext = K;
exports.getGlobalEmitter = Ea;
exports.getGlobalLogger = Ee;
exports.getGlobalLoggerIfExists = nt;
exports.getNamespaceFilterString = Tn;
exports.getNavigator = Pr;
exports.getSecureRandom = Rn;
exports.getSecureRandomIfPossible = S;
exports.getSourceLocation = Ke;
exports.getSourceLocationByPrecedingPattern = pn;
exports.getStack = dn;
exports.getStackLlocationList = Yr;
exports.getTimestamp = ie;
exports.getWebCrypto = rc;
exports.getWindow = tn;
exports.immediate = _i;
exports.isArray = G;
exports.isBoolean = Mt;
exports.isBrowser = Dr;
exports.isEven = Bt;
exports.isHalf = re;
exports.isInteger = ts;
exports.isLocalHost = Ru;
exports.isNotNull = Ft;
exports.isNull = os;
exports.isNullOrUndefined = rs;
exports.isNumber = Ut;
exports.isObject = H;
exports.isPrime = _o;
exports.isPrimeRX = Bo;
exports.isPrimitive = _e;
exports.isPromise = k;
exports.isRecord = ye;
exports.isRecordPlain = es;
exports.isSafeInteger = ns;
exports.isString = Rt;
exports.isTimeout = Ni;
exports.isUint8Array = is;
exports.isValue = ss;
exports.joinToUint8Array = Eo;
exports.jsonStringify = Lo;
exports.jsonStringifySafe = M;
exports.jsonStringifySorted = wo;
exports.jsonToUint8Array = Pe;
exports.last = Ws;
exports.lazyListener = Pa;
exports.linkifyPlainText = js;
exports.listDistinctUnion = gs;
exports.listGroupBy = ps;
exports.listOfKey = ms;
exports.listQuery = ds;
exports.loggerStackTraceDebug = no;
exports.memoize = Ks;
exports.memoizeAsync = Ys;
exports.moveSortWeight = Cs;
exports.noop = Ju;
exports.objectIsEmpty = Ts;
exports.objectMap = xs;
exports.objectMergeDisposable = bs;
exports.parseArgs = Yu;
exports.parseBasicAuth = Ar;
exports.parseDate = Sa;
exports.parseLogLevel = ve;
exports.parseOrderby = Mn;
exports.parseQuery = Ns;
exports.pbcopy = Xu;
exports.promisify = N;
exports.qid = _a;
exports.randomBoolean = ko;
exports.randomFloat = Io;
exports.randomInt = Co;
exports.randomUint8Array = Q;
exports.readText = wc;
exports.regExpEscape = ea;
exports.regExpString = or;
exports.removeFolder = Tc;
exports.renderMessages = pe;
exports.roundDown = Es;
exports.roundHalfAwayFromZero = Ss;
exports.roundHalfDown = Rs;
exports.roundHalfEven = Us;
exports.roundHalfOdd = Ds;
exports.roundHalfTowardsZero = Ms;
exports.roundHalfUp = Ps;
exports.roundUp = As;
exports.seededRandom = jo;
exports.setUuidDefaultEncoding = Oa;
exports.setupEnv = uc;
exports.setupWebCrypto = nc;
exports.size = qs;
exports.sleep = Bi;
exports.sortedItems = Xn;
exports.sortedOrderby = Go;
exports.startSortWeight = _t;
exports.stringToBoolean = bi;
exports.stringToFloat = wi;
exports.stringToInteger = Ti;
exports.stringToPath = kr;
exports.stringToUInt8Array = ot;
exports.suid = Ca;
exports.suidBytes = qt;
exports.suidBytesDate = br;
exports.suidDate = Ia;
exports.sum = Un;
exports.throttle = Pu;
exports.timeout = ji;
exports.toBase64 = ut;
exports.toBase64Url = Po;
exports.toBool = Ei;
exports.toCamelCase = Tt;
exports.toCapitalize = _n;
exports.toCapitalizeWords = mi;
exports.toFloat = Li;
exports.toHex = st;
exports.toHumanReadableFilePath = xc;
exports.toHumanReadableUrl = tr;
exports.toInt = vi;
exports.toPath = We;
exports.toString = Ai;
exports.toUint8Array = F;
exports.toValidFilename = $t;
exports.today = qi;
exports.tryTimeout = St;
exports.uname = B;
exports.unescapeHTML = ls;
exports.useAsyncMutex = xa;
exports.useBase = q;
exports.useDefer = fa;
exports.useDispose = oe;
exports.useDisposer = la;
exports.useEventListener = ga;
exports.useExitHandler = zu;
exports.useInterval = pa;
exports.useLevelFilter = z;
exports.useMessageHub = Xa;
exports.useMutex = ha;
exports.useNamespaceFilter = _;
exports.usePool = xu;
exports.usePubSub = iu;
exports.useRPC = au;
exports.useSorted = Os;
exports.useTimeout = da;
exports.uuid = J;
exports.uuid32bit = $a;
exports.uuidB32 = fr;
exports.uuidB62 = ur;
exports.uuidBytes = Ne;
exports.uuidDecode = Jt;
exports.uuidDecodeB32 = pr;
exports.uuidDecodeB62 = lr;
exports.uuidDecodeV4 = hr;
exports.uuidEncode = Tr;
exports.uuidEncodeB32 = dr;
exports.uuidEncodeB62 = cr;
exports.uuidEncodeV4 = yr;
exports.uuidIsValid = Ba;
exports.uuidv4 = mr;
exports.valueToBoolean = ee;
exports.valueToFloat = Nn;
exports.valueToInteger = jn;
exports.valueToPath = Cr;
exports.valueToString = Ie;
exports.waitOn = Hi;
exports.writeText = Lc;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=index.node.cjs.map